#include "http.h"
#include <uv.h>
#include <td/telegram/td_api.h>
#include <td/telegram/td_api.hpp>

void on_signal(uv_signal_t *h, int signum) {
  uv_stop(uv_default_loop());
}

int main() {
  uv_loop_t *loop = uv_default_loop();

  http::HttpClient httpClient(loop);
  spdlog::info("sending request");
  httpClient.send_request("GET", "https://slavasil.ru/", {}, [](auto resp, CURLcode code){
    if (code == 0) {
      spdlog::info("got response! {} {}", resp->status, resp->body);
    } else {
      spdlog::error("got error!");
    }
  });
  uv_signal_t signalHandles[2] = {};
  uv_signal_init(loop, signalHandles);
  uv_signal_start(signalHandles, on_signal, SIGINT);
  uv_signal_init(loop, signalHandles + 1);
  uv_signal_start(signalHandles + 1, on_signal, SIGTERM);
  
  uv_run(loop, UV_RUN_DEFAULT);
  spdlog::info("event loop ended");
  return 0;
}
